#!/usr/bin/env python
# 

import sys
import os
import os.path
sys.path.append(os.path.join(os.path.dirname(sys.argv[0]), 'simplejson-2.1.0'))
import simplejson as json

DST_JSON_FILE = 'external_extensions.json'
EXTENSIONS_DIR = 'extensions'
#CHROME_PATH = '/opt/google/chrome'
CHROME_PATH= '/usr/lib/chromium-browser'
CHROMIUM_PATH = '/usr/lib/chromium-browser'

def print_help():
    print 'installer.py [install|unisntall] [extension_json_file]'
    pass

def install_path(src_json, chrome_path):
    #print 'install'
    if os.path.exists(chrome_path):
        #print 'chrome is installed'
        extensions_path = os.path.join(chrome_path, EXTENSIONS_DIR)
        if not os.path.exists(extensions_path):
            #print 'extensions dir doens\'t exist'
            os.mkdir(extensions_path)
            #print 'extensions dir creates'
            pass
        #print 'extension dir is there'
        dst_json_file_path = (os.path.join(chrome_path, EXTENSIONS_DIR, DST_JSON_FILE))
        if not os.path.exists(dst_json_file_path):
            #print 'dst json file does not exisit'
            try:
                dst_json_file = open(dst_json_file_path, "w+")
                json.dump(src_json, dst_json_file, indent=4)
                dst_json_file.close()
                #print 'success to create file', dst_json_file_path
            except:
                #print 'error to create file ', dst_json_file_path
                return
            pass
        else:
            try:
                dst_json_file = open(dst_json_file_path, "r")
                dst_json = json.load(dst_json_file)
                dst_json_file.close()
                dst_json_file = open(dst_json_file_path, "w+")
                #print 'succes to open file', dst_json_file_path
            except:
                #print 'error to open file ', dst_json_file_path
                return
            id = src_json.items()[0][0]
            value = src_json.items()[0][1]
            dst_json[id] = value
            #print dst_json
            json.dump(dst_json, dst_json_file, indent=4)
            dst_json_file.close()
            pass
        pass
    pass

def install(src_json):
    if os.path.exists(CHROME_PATH):
        install_path(src_json, CHROME_PATH)
        pass
    if os.path.exists(CHROMIUM_PATH):
        install_path(src_json, CHROMIUM_PATH)
        pass
    pass

def uninstall_path(src_json, chrome_path):
    #print 'uninstall'
    if os.path.exists(chrome_path):
        dst_json_file_path = (os.path.join(chrome_path, EXTENSIONS_DIR, DST_JSON_FILE))
        if os.path.exists(dst_json_file_path):
            try:
                dst_json_file = open(dst_json_file_path, "r")
                dst_json = json.load(dst_json_file)
                dst_json_file.close()
                dst_json_file = open(dst_json_file_path, "w+")
                #print 'succes to open file', dst_json_file_path
            except:
                #print 'error to open file ', dst_json_file_path
                return
            id = src_json.items()[0][0]
            value = src_json.items()[0][1]
            if dst_json.has_key(id):
                dst_json.pop(id)
            #print dst_json
            json.dump(dst_json, dst_json_file, indent=4)
            dst_json_file.close()
            pass
        pass
    pass

def uninstall(src_json):
    if os.path.exists(CHROME_PATH):
        uninstall_path(src_json, CHROME_PATH)
        pass
    if os.path.exists(CHROMIUM_PATH):
        uninstall_path(src_json, CHROMIUM_PATH)
        pass
    pass

def main(args):
    try:
        src_json_file = open(args[1])
        src_json = json.load(src_json_file)
    except:
        #print 'error to open ', args[1]
        return -1
    if args[0] == 'install':
        install(src_json)
    elif args[0] == 'uninstall':
        uninstall(src_json)
    else:
        print_help()
    src_json_file.close()
    return 0
    pass

if __name__ == '__main__':
    if (len(sys.argv) < 3):
        print_help()
        sys.exit(-1)
    sys.exit(main(sys.argv[1:]))
